gwas.Fast-EB-LMM <- function(dataframe, gen, map,  kk.eigen, mixed, cc){ #winsize
   ## data
   ##   
   d <- dataframe
   y <- as.matrix(d[,1])
   x <- as.matrix(d[,-1])   
   n <- nrow(d)
   r <- ncol(d)-1
   ##         
   z <- as.matrix(t(gen))    
   nm <- ncol(z)
   ##
   #pos <- as.numeric(map[,4])
   #pos.start <- min(pos)
   #pos.end <- max(pos)
   ##
   uu <- kk.eigen$vectors
   delta <- kk.eigen$values
   xu <- crossprod(uu,x)
   zu <- crossprod(uu,z)
   ##
   lambda <- as.numeric(mixed$tau[3])
   fn0 <- as.numeric(mixed$fn)
   ##
   H <- delta*lambda+1
   H_sqrt <- sqrt(H)
   
   xh0 <- sweep(xu, 1, H_sqrt, "/")
   xx0 <- crossprod(xh0)     
   yu <- crossprod(uu,y)    
   yh <- yu/H_sqrt
   yy <- sum(yh^2) 

   ###scan genetic variants one by one
   parr <- lapply(1:nm, function(i){
   ###
     xnew <- cbind(xu,zu[,i])
     iz <- ncol(xnew)
     xnew <- as.matrix(xnew)
     #
     #winlower <- max(pos[i] - 0.5 * winsize, pos.start)
     #winupper <- min(pos[i] + 0.5 * winsize, pos.end)
     #k1 <- min(which(pos>=winlower))  
     #k2 <- max(which(pos<=winupper))
     k1 <- max(i-100,1)
     k2 <- min(i+100,nm)
     sub.rm <- k1:k2
     nrm <- k2-k1+1
     zr <- as.matrix(zu[,sub.rm])/sqrt(cc)
     
     zh <- sweep(zr, 1, H_sqrt, "/")
     zz <- crossprod(zh)
     zz_inv <- solve(zz - diag(rep(1/lambda,nrm)), tol=1e-100)
     
     xh <- sweep(xnew, 1, H_sqrt, "/")
     xx <- crossprod(xh)
     xy <- crossprod(xh,yh)
     xz <- crossprod(xh,zh)
     yz <- crossprod(yh,zh)
       
     xvx <- xx - xz %*% zz_inv %*% t(xz) + as.matrix(diag(rep(1,iz)))*1e-04
     yvy <- yy - yz %*% zz_inv %*% t(yz)
     xvy <- xy - xz %*% zz_inv %*% t(yz)  
     xvx_inv <- solve(xvx,tol=1e-100)
     p <- abs(yvy - t(xvy) %*% xvx_inv %*% xvy)     
     se2 <- as.numeric(p/(n-iz))
     
     ### wald test statistics                           
     b <- xvx_inv %*% xvy
     vb <- xvx_inv * se2
     bi <- as.numeric(b[iz])
     vbi <- as.numeric(vb[iz,iz])
     ##wald
     wald <- bi^2/vbi
     p.wald <- pchisq(wald,df=1, lower.tail=FALSE, log.p=FALSE)
     logp.wald <- -pchisq(wald, df=1, lower.tail=FALSE, log.p=TRUE)/log(10) 
          
     ###likelihood value in the tested model    
     #zzi <- diag(rep(1,nrm)) - zz * lambda
     #d0 <-  sum(log(abs(H)))+ unlist(determinant(zzi))[1]
     #d1 <- unlist(determinant(xvx))[1]
     #cc_fn <- (n-iz)*(1-log(n-iz))
     #fn1 <- -0.5 * (d0 + d1 + (n-iz) * log(p) + cc_fn)
     xy0 <- crossprod(xh0,yh)
     xz0 <- crossprod(xh0,zh)
     xvy0 <- xy0 - xz0 %*% zz_inv %*% t(yz)
     xvx0 <- xx0 - xz0 %*% zz_inv %*% t(xz0) + as.matrix(diag(rep(1,r)))*1e-04
     xvx0_inv <- solve(xvx0,tol=1e-100)
     p_null <- abs(yvy - t(xvy0) %*% xvx0_inv %*% xvy0)   
     fn1 <- -0.5 * (n-iz) * log(p/(n-iz))
     fn0 <- -0.5 * (n-iz) * log(p_null/(n-iz))
            
     ###lrt test significance
     lrt <- -2 * (fn0 - fn1)
     p.lrt <- pchisq(lrt,df=1,lower.tail=FALSE,log.p=FALSE)
     logp.lrt <- -pchisq(lrt,df=1,lower.tail=FALSE,log.p=TRUE)/log(10)
     ###
     parri <- c(bi, vbi, wald, p.wald, logp.wald, lrt, p.lrt, logp.lrt)  
     return(parri)     
   })
   ###
   parr <- as.data.frame(do.call(rbind,parr))
   names(parr) <- c("b", "vb", "wald", "p.wald", "logp.wald", "lrt", "p.lrt", "logp.lrt")
   parr <- cbind(map,parr)
   return(parr)
}